/***************************************************************************
      dialogprogress.cpp  -  Dialog with progress bar and Cancel button
     -------------------------------------------------------------------
    begin                : Sat Jan 20 2001
    copyright            : (C) 2001 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "dialogprogress.h"

#include <gnome--/stock.h>


DialogProgress::DialogProgress(string title, string label) : Gtk::Window(GTK_WINDOW_DIALOG) {
//  Gtk::Button *cancel = manage(new Gtk::Button(but));
  Gnome::StockButton *cancel = manage(new Gnome::StockButton(GNOME_STOCK_BUTTON_CANCEL));

  cancel->clicked.connect(slot(this, &DialogProgress::cancel_pressed));

  adj = manage(new Gtk::Adjustment(0, 0, 100, 0.5));
  Gtk::ProgressBar *progressbar = manage(new Gtk::ProgressBar(*adj));
  progressbar->set_show_text(true);

  Gtk::VBox *vbox = manage(new Gtk::VBox(false,10));

  lab = manage(new Gtk::Label(label));
  vbox->pack_start(*lab);
  vbox->pack_start(*progressbar);
  vbox->pack_start(*cancel, false, false);

  set_modal(true);
  set_border_width(10);
  set_title(title);
  set_policy(false, true, false);    // set fixed size of window

  add(*vbox);

  cancel->set_flags(GTK_CAN_DEFAULT);   // set 'Cancel' default button
  cancel->grab_default();

  canc = false;
  show_all();
}

DialogProgress::~DialogProgress() {

}

void DialogProgress::cancel_pressed() {
  canc = true;
  canceled.emit();
}

void DialogProgress::set_progress(float val) {
  if (val >= 0.0 && val <= 100.0)
    adj->set_value(val);
}

void DialogProgress::set_label(string l) {
  lab->set_text(l);
}

int DialogProgress::delete_event_impl(GdkEventAny* e) {
  return true;            // disable destroying window by WM
}
