/***************************************************************************
          dialogtageditor.cpp  -  Dialog for setting ID3 tag values
         -----------------------------------------------------------
    begin                : Sat Mar 31 2001
    copyright            : (C) 2001 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "dialogtageditor.h"

#include <libgnome/gnome-i18n.h>


DialogTagEditor::DialogTagEditor() : Gtk::Window(GTK_WINDOW_DIALOG) {
  set_modal(true);
  set_title(_("ID3 tag editor"));
  set_policy(false, false, false);    // set fixed size of window

  Gtk::Label *label_title = manage(new Gtk::Label(_("Title")));
  Gtk::Label *label_artist = manage(new Gtk::Label(_("Artist")));
  Gtk::Label *label_album = manage(new Gtk::Label(_("Album")));
  Gtk::Label *label_comment = manage(new Gtk::Label(_("Comment")));
  Gtk::Label *label_year = manage(new Gtk::Label(_("Year")));
  Gtk::Label *label_genre = manage(new Gtk::Label(_("Genre")));
  label_title->set_alignment(1, 0.5);
  label_artist->set_alignment(1, 0.5);
  label_album->set_alignment(1, 0.5);
  label_comment->set_alignment(1, 0.5);
  label_year->set_alignment(1, 0.5);
  entry_title = manage(new Gtk::Entry(30));
  entry_artist = manage(new Gtk::Entry(30));
  entry_album = manage(new Gtk::Entry(30));
  entry_comment = manage(new Gtk::Entry(30));
  entry_year = manage(new Gtk::Entry(4));
  entry_year->set_usize(60, -1);

//  entry_title->set_text("tile");
//  entry_artist->set_text("artisr");
//  entry_album->set_text("album");
//  entry_comment->set_text("comm");
//  entry_year->set_text("year");


//  list<string> combo_list;
  combo_list.push_back("");
  combo_list.push_back("Blues");
  combo_list.push_back("Classic Rock");
  combo_list.push_back("Country");
  combo_list.push_back("Dance");
  combo_list.push_back("Disco");
  combo_list.push_back("Funk");
  combo_list.push_back("Grunge");
  combo_list.push_back("Hip-Hop");
  combo_list.push_back("Jazz");
  combo_list.push_back("Metal");
  combo_list.push_back("New Age");
  combo_list.push_back("Oldies");
  combo_list.push_back("Other");
  combo_list.push_back("Pop");
  combo_list.push_back("R&B");
  combo_list.push_back("Rap");
  combo_list.push_back("Reggae");
  combo_list.push_back("Rock");
  combo_list.push_back("Techno");
  combo_list.push_back("Industrial");
  combo_list.push_back("Alternative");
  combo_list.push_back("Ska");
  combo_list.push_back("Death Metal");
  combo_list.push_back("Pranks");
  combo_list.push_back("Soundtrack");
  combo_list.push_back("Euro-Techno");
  combo_list.push_back("Ambient");
  combo_list.push_back("Trip-Hop");
  combo_list.push_back("Vocal");
  combo_list.push_back("Jazz+Funk");
  combo_list.push_back("Fusion");
  combo_list.push_back("Trance");
  combo_list.push_back("Classical");
  combo_list.push_back("Instrumental");
  combo_list.push_back("Acid");
  combo_list.push_back("House");
  combo_list.push_back("Game");
  combo_list.push_back("Sound Clip");
  combo_list.push_back("Gospel");
  combo_list.push_back("Noise");
  combo_list.push_back("AlternRock");
  combo_list.push_back("Bass");
  combo_list.push_back("Soul");
  combo_list.push_back("Punk");
  combo_list.push_back("Space");
  combo_list.push_back("Meditative");
  combo_list.push_back("Instrumental Pop");
  combo_list.push_back("Instrumental Rock");
  combo_list.push_back("Ethnic");
  combo_list.push_back("Gothic");
  combo_list.push_back("Darkwave");
  combo_list.push_back("Techno-Industrial");
  combo_list.push_back("Electronic");
  combo_list.push_back("Pop-Folk");
  combo_list.push_back("Eurodance");
  combo_list.push_back("Dream");
  combo_list.push_back("Southern Rock");
  combo_list.push_back("Comedy");
  combo_list.push_back("Cult");
  combo_list.push_back("Gangsta Rap");
  combo_list.push_back("Top 40");
  combo_list.push_back("Christian Rap");
  combo_list.push_back("Pop/Funk");
  combo_list.push_back("Jungle");
  combo_list.push_back("Native American");
  combo_list.push_back("Cabaret");
  combo_list.push_back("New Wave");
  combo_list.push_back("Psychadelic");
  combo_list.push_back("Rave");
  combo_list.push_back("Showtunes");
  combo_list.push_back("Trailer");
  combo_list.push_back("Lo-Fi");
  combo_list.push_back("Tribal");
  combo_list.push_back("Acid Punk");
  combo_list.push_back("Acid Jazz");
  combo_list.push_back("Polka");
  combo_list.push_back("Retro");
  combo_list.push_back("Musical");
  combo_list.push_back("Rock & Roll");
  combo_list.push_back("Hard Rock");

  combo_genre = manage(new Gtk::Combo);
  combo_genre->set_popdown_strings(combo_list);
  combo_genre->set_value_in_list(true, false);            // value must be in list
  combo_genre->get_entry()->set_editable(false);          // disable editing text

  Gtk::HBox *hbox = manage(new Gtk::HBox(false, 5));
  hbox->pack_start(*entry_year, false, false, 0);
  hbox->pack_end(*combo_genre, false, false, 0);
  hbox->pack_end(*label_genre, false, false, 0);


  Gtk::Table *table_tag = manage(new Gtk::Table(5, 2, false));
  table_tag->attach(*label_title, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
  table_tag->attach(*label_artist, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
  table_tag->attach(*label_album, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
  table_tag->attach(*label_comment, 0, 1, 3, 4, GTK_FILL, 0, 0, 0);
  table_tag->attach(*label_year, 0, 1, 4, 5, GTK_FILL, 0, 0, 0);
  table_tag->attach(*hbox, 1, 2, 4, 5, GTK_FILL, GTK_FILL, 0, 0);
  table_tag->attach(*entry_title, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
  table_tag->attach(*entry_artist, 1, 2, 1, 2, GTK_EXPAND|GTK_FILL, 0, 0, 0);
  table_tag->attach(*entry_album, 1, 2, 2, 3, GTK_EXPAND|GTK_FILL, 0, 0, 0);
  table_tag->attach(*entry_comment, 1, 2, 3, 4, GTK_EXPAND|GTK_FILL, 0, 0, 0);
  table_tag->set_border_width(5);
  table_tag->set_row_spacings(5);
  table_tag->set_col_spacings(5);

  Gtk::Frame *frame_tag = manage(new Gtk::Frame(_("ID3 tag properties")));
  frame_tag->add(*table_tag);
  frame_tag->set_border_width(3);


  Gnome::StockButton *button_ok = manage(new Gnome::StockButton(GNOME_STOCK_BUTTON_OK));
  button_ok->clicked.connect(slot(this, &DialogTagEditor::button_pressed));

  Gtk::HButtonBox *hbuttonbox = manage(new Gtk::HButtonBox(GTK_BUTTONBOX_SPREAD, 5));
  hbuttonbox->add(*button_ok);
  hbuttonbox->set_border_width(5);


  Gtk::VBox *vbox = manage(new Gtk::VBox(false, 3));
  vbox->pack_start(*frame_tag, false, false);
  vbox->pack_start(*hbuttonbox, false, false);
  vbox->set_border_width(5);
  add(*vbox);

}

DialogTagEditor::~DialogTagEditor() {

}

char DialogTagEditor::get_genre() {
  unsigned int genres = combo_list.size(), id = 0;
  string text = combo_genre->get_entry()->get_text();

  while (id < genres && combo_list[id] != text) id++;
  id--;

  return static_cast<char>(id);
}

void DialogTagEditor::button_pressed() {
#ifdef DEBUG_OUTPUT
  cerr << "title = " << get_title() << endl;
  cerr << "artist = " << get_artist() << endl;
  cerr << "album = " << get_album() << endl;
  cerr << "comment = " << get_comment() << endl;
  cerr << "year = " << get_year() << endl;
  cerr << "genre index = " << static_cast<int>(get_genre()) << endl;
#endif

  ok_clicked.emit();
  hide();
}

int DialogTagEditor::delete_event_impl(GdkEventAny* e) {
  return true;            // disable closing window by WM
}
