/***************************************************************************
             gnomeconfig.cpp  -  C++ wrapper for gnome-config.h
            ----------------------------------------------------
    begin                : Fri Apr 20 2001
    copyright            : (C) 2001 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "gnomeconfig.h"

#include <gnome.h>
#include <libgnome/gnome-config.h>


GnomeConfig::GnomeConfig() {
}

GnomeConfig::~GnomeConfig() {
  sync();
}

int GnomeConfig::get_integer(string path) {
  return gnome_config_get_int(path.c_str());
}

string GnomeConfig::get_string(string path) {
  char *tmp = gnome_config_get_string(path.c_str());
  string val(tmp);

  g_free(tmp);
  return val;
}

double GnomeConfig::get_float(string path) {
  return gnome_config_get_float(path.c_str());
}

bool GnomeConfig::get_bool(string path) {
  return gnome_config_get_bool(path.c_str());
}
	
void GnomeConfig::set_string(string path, string value) {
  gnome_config_set_string(path.c_str(), value.c_str());
}

void GnomeConfig::set_float(string path, double value) {
  gnome_config_set_float(path.c_str(), value);
}

void GnomeConfig::set_bool(string path, bool value) {
  gnome_config_set_bool(path.c_str(), value);
}

void GnomeConfig::set_integer(string path, int value) {
  gnome_config_set_int(path.c_str(), value);
}
	
void GnomeConfig::push_prefix(string prefix) {
  gnome_config_push_prefix(prefix.c_str());
}

void GnomeConfig::pop_prefix() {
  gnome_config_pop_prefix();
}

void GnomeConfig::sync() {
  // write changes
  gnome_config_sync();
}
