/***************************************************************************
             ossdevice.h  -  Implementation of OSS interface
            -------------------------------------------------
    begin                : Tue Feb 1 2000
    copyright            : (C) 2000 by Ladislav Slezk
    email                : slezak@penguin.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OSSDEVICE_H
#define OSSDEVICE_H

#include "sounddevice.h"

#include <sys/soundcard.h>

/**Open Sound System interface
  *@author Ladislav Slezk
  */

class OSSdevice : public SoundDevice  {

  public:

  	OSSdevice();
  	virtual ~OSSdevice();

    virtual bool open_device();
    virtual bool opened();
    virtual bool close_device();
    virtual bool set_frequency(int freq);
    virtual int get_frequency();
    virtual bool set_number_of_channels(int ch);
    virtual int get_number_of_channels();
    virtual bool play(char *, int);
    virtual bool stop();
    virtual string get_info();
    virtual bool set_format(bits);
    virtual bits get_format();
    virtual void reset();

    virtual void set_device(string dev) {device = dev;}
    virtual string get_device() {return device;}
    virtual int get_processed_bytes();
    virtual int get_processed_ms();

  private:

    bool OSSopened;         // device opened
    int audio_fd;           // file descriptor
    int freq;               // sampling frequency
    int channels;           // number sound channels
    bits format;            // 16 bit or 8 bit data format
		int bufferSize;         // output buffer size

    string device;
 	  	
};

#endif
